"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "BreadCrumbLink", {
  enumerable: true,
  get: function () {
    return _primitives.Link;
  }
});
Object.defineProperty(exports, "BreadCrumbItem", {
  enumerable: true,
  get: function () {
    return _BreadCrumbItem.default;
  }
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _primitives = require("../../primitives");

var _tools = require("../../../theme/tools");

var _BreadCrumbSeparator = require("./BreadCrumbSeparator");

var _hooks = require("../../../hooks");

var _BreadCrumbItem = _interopRequireDefault(require("./BreadCrumbItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const BreadCrumb = ({
  style,
  children,
  separator,
  spacing,
  ...props
}) => {
  const [textProps, remainingProps] = (0, _tools.extractInObject)(props, ['fontWeight', 'fontFamily', 'fontSize', 'color', 'textDecoration', 'txtDecor', 'wordBreak', 'textOverflow', 'textTransform', 'whiteSpace', 'overflowWrap', 'bold', 'italic', 'underline', 'strikeThrough', 'isTruncated', 'noOfLines']);
  let newProps = (0, _hooks.useThemeProps)('BreadCrumb', remainingProps);
  return /*#__PURE__*/_react.default.createElement(_primitives.Flex, _extends({}, newProps, {
    style: style
  }), children && !children.length ? children : (0, _BreadCrumbSeparator.getBreadCrumbSeparator)(children, separator, textProps, spacing));
};

var _default = /*#__PURE__*/_react.default.memo(BreadCrumb);

exports.default = _default;
//# sourceMappingURL=index.js.map