"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ButtonGroup = void 0;

var _react = _interopRequireDefault(require("react"));

var _native = _interopRequireDefault(require("styled-components/native"));

var _styledSystem = require("styled-system");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const StyledButtonGroup = _native.default.View(_styledSystem.color, _styledSystem.space, _styledSystem.layout, _styledSystem.flexbox, _styledSystem.border, {
  flexDirection: 'row',
  flexWrap: 'wrap'
});

const ButtonGroup = /*#__PURE__*/_react.default.memo(({
  children,
  spacing,
  ...props
}) => {
  return /*#__PURE__*/_react.default.createElement(StyledButtonGroup, null, _react.default.Children.map(children, (child, index) => {
    return /*#__PURE__*/_react.default.cloneElement(child, {
      ml: index !== 0 ? spacing : undefined,
      ...props
    });
  }));
});

exports.ButtonGroup = ButtonGroup;
//# sourceMappingURL=ButtonGroup.js.map