"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Path", {
  enumerable: true,
  get: function () {
    return _reactNativeSvg.Path;
  }
});
Object.defineProperty(exports, "createIcon", {
  enumerable: true,
  get: function () {
    return _createIcon.createIcon;
  }
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

var _styledSystem = require("styled-system");

var _customProps = require("../../../utils/customProps");

var _hooks = require("../../../hooks");

var _native = _interopRequireDefault(require("styled-components/native"));

var _vectorIcons = require("@expo/vector-icons");

var _SVGIcon = _interopRequireDefault(require("./SVGIcon"));

var _reactNativeSvg = require("react-native-svg");

var _createIcon = require("./createIcon");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const Icon = (iconProps, ref) => {
  const {
    name,
    type,
    size,
    color: colorProp,
    ...props
  } = iconProps;
  const newProps = (0, _hooks.useThemeProps)('Icon', {
    size,
    color: colorProp
  });
  const rawColor = (0, _hooks.useToken)('colors', newProps.color);

  if (!name) {
    return /*#__PURE__*/_react.default.createElement(_SVGIcon.default, iconProps);
  }

  const flattenedIconStyle = _reactNative.StyleSheet.flatten([{
    fontSize: parseInt(newProps.size, 10)
  }]);

  switch (type) {
    case 'AntDesign':
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.AntDesign // TODO: remove this
      // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'Entypo':
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.Entypo // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'EvilIcons':
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.EvilIcons // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'Feather':
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.Feather // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'FontAwesome':
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.FontAwesome // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'FontAwesome5':
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.FontAwesome5 // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'Foundation':
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.Foundation // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'Ionicons':
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.Ionicons // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'MaterialCommunityIcons':
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.MaterialCommunityIcons // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'Octicons':
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.Octicons // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'SimpleLineIcons':
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.SimpleLineIcons // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'Zocial':
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.Zocial // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    default:
      return /*#__PURE__*/_react.default.createElement(_vectorIcons.MaterialIcons // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));
  }
};

const styledIcon = (0, _native.default)( /*#__PURE__*/_react.default.forwardRef(Icon))(_styledSystem.color, _styledSystem.space, _styledSystem.layout, _styledSystem.flexbox, _styledSystem.border, _styledSystem.typography, _styledSystem.position, _customProps.customPosition, _customProps.customBorder, _customProps.customBackground, _customProps.customOutline, _customProps.customShadow, _customProps.customExtra, _customProps.customLayout, _customProps.customTypography);

var _default = /*#__PURE__*/_react.default.memo(styledIcon);

exports.default = _default;
//# sourceMappingURL=index.js.map