"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _toggle = require("@react-stately/toggle");

var _reactNative = require("react-native");

var _native = _interopRequireDefault(require("styled-components/native"));

var _isNil = _interopRequireDefault(require("lodash/isNil"));

var _hooks = require("../../../hooks");

var _styledSystem = require("styled-system");

var _customProps = require("../../../utils/customProps");

var _reactNativeAria = require("react-native-aria");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const StyledNBSwitch = (0, _native.default)(_reactNative.Switch)(_styledSystem.color, _styledSystem.space, _styledSystem.layout, _styledSystem.flexbox, _styledSystem.border, _styledSystem.position, _customProps.customPosition, _customProps.customBorder, _customProps.customBackground, _customProps.customOutline, _customProps.customShadow, _customProps.customExtra, _customProps.customLayout);

const Switch = ({
  style,
  onToggle,
  isDisabled,
  isInvalid,
  iosBgColor,
  isChecked,
  defaultIsChecked,
  accessibilityLabel,
  accessibilityHint,
  onColor,
  offColor,
  ...props
}, ref) => {
  var _newProps$transform;

  const state = (0, _toggle.useToggleState)({
    defaultSelected: !(0, _isNil.default)(defaultIsChecked) ? defaultIsChecked : false
  });
  const borderColorInvalid = (0, _hooks.useToken)('colors', 'danger.600');
  const checked = !(0, _isNil.default)(isChecked) ? isChecked : state.isSelected;
  const newProps = (0, _hooks.useThemeProps)('Switch', { ...props,
    checked,
    onColor,
    offColor
  });
  const inValidPropFactors = {
    borderWidth: 1,
    borderRadius: 16,
    borderColor: borderColorInvalid
  };

  let computedStyle = _reactNative.StyleSheet.flatten([style, {
    transform: (_newProps$transform = newProps.transform) !== null && _newProps$transform !== void 0 ? _newProps$transform : undefined
  }, isInvalid ? inValidPropFactors : {}]);

  const inputRef = _react.default.useRef(null);

  let {
    inputProps
  } = (0, _reactNativeAria.useSwitch)({
    'aria-label': accessibilityLabel,
    'aria-describedby': accessibilityHint,
    isDisabled
  }, state, inputRef);
  return /*#__PURE__*/_react.default.createElement(_reactNativeAria.AriaInputWrapper, _extends({}, inputProps, {
    ref: inputRef
  }), /*#__PURE__*/_react.default.createElement(StyledNBSwitch, _extends({}, newProps, {
    disabled: isDisabled,
    ios_backgroundColor: iosBgColor,
    onValueChange: onToggle ? onToggle : state.toggle,
    value: checked,
    style: computedStyle,
    ref: ref,
    opacity: isDisabled ? 0.4 : 1
  })));
};

var _default = /*#__PURE__*/_react.default.memo( /*#__PURE__*/_react.default.forwardRef(Switch));

exports.default = _default;
//# sourceMappingURL=index.js.map