function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import Box from '../../primitives/Box';
import { useToken } from '../../../hooks';
import { AccordionItemContext } from './Context';
import Collapse from '../Collapse';

const AccordionPanel = ({
  children,
  ...props
}) => {
  const {
    isOpen
  } = React.useContext(AccordionItemContext);
  const borderColor = useToken('colors', 'muted.200');
  return /*#__PURE__*/React.createElement(Collapse, {
    isOpen: isOpen
  }, /*#__PURE__*/React.createElement(Box, _extends({
    p: 3,
    borderColor: borderColor
  }, props), children));
};

export default /*#__PURE__*/React.memo(AccordionPanel);
//# sourceMappingURL=AccordionPanel.js.map