function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { useThemeProps } from '../../../hooks';
import AppBarLeft from './AppBarLeft';
import AppBarRight from './AppBarRight';
import AppBarContent from './AppBarContent';
import { HStack } from '../../primitives';
import { APPROX_STATUSBAR_HEIGHT } from './utils';

const AppBarInternal = ({
  children,
  ...props
}) => {
  const {
    statusBarHeight = APPROX_STATUSBAR_HEIGHT,
    ...newProps
  } = useThemeProps('AppBar', props);
  return /*#__PURE__*/React.createElement(HStack, _extends({
    mt: statusBarHeight
  }, newProps), children);
};

AppBarInternal.Left = /*#__PURE__*/React.memo(AppBarLeft);
AppBarInternal.Right = /*#__PURE__*/React.memo(AppBarRight);
AppBarInternal.Content = /*#__PURE__*/React.memo(AppBarContent);
const AppBar = /*#__PURE__*/React.memo(AppBarInternal);
export default AppBar;
//# sourceMappingURL=AppBar.js.map