import React from 'react';
import Flex from '../../primitives/Flex';

const BreadCrumbItem = props => {
  const {
    children,
    isCurrentPage,
    ...remainingProps
  } = props;
  return /*#__PURE__*/React.createElement(Flex, remainingProps, React.Children.map(children, (child, index) => {
    return /*#__PURE__*/React.cloneElement(child, {
      key: "breadcrumb-item-".concat(index),
      ...remainingProps,
      ...{
        isUnderlined: isCurrentPage ? false : undefined
      }
    });
  }));
};

export default /*#__PURE__*/React.memo(BreadCrumbItem);
//# sourceMappingURL=BreadCrumbItem.js.map