import React from 'react';
import isNil from 'lodash/isNil';
import Text from '../../primitives/Text';
export const getBreadCrumbSeparator = (children, separator, props, spacing) => {
  if (Array.isArray(children)) {
    if (children.length === 1) {
      return children;
    }

    const separatorElement = separator ? typeof separator === 'string' ? /*#__PURE__*/React.createElement(Text, {
      mx: !isNil(spacing) ? spacing : 2
    }, separator) : /*#__PURE__*/React.cloneElement(separator, {
      mx: !isNil(spacing) ? spacing : 2
    }) : /*#__PURE__*/React.createElement(Text, {
      mx: !isNil(spacing) ? spacing : 2
    }, '/');
    let result = [];

    if (children && children.length > 1) {
      result = children.reduce((r, a) => r.concat(a, separatorElement), [separatorElement]);
    }

    result = result.slice(1, -1);
    return result.map((child, index) => {
      return /*#__PURE__*/React.cloneElement(child, { ...props,
        key: "breadcrumb-separator-".concat(index)
      });
    });
  } else {
    return children;
  }
};
//# sourceMappingURL=BreadCrumbSeparator.js.map