function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { useThemeProps } from '../../../hooks';
import { useToken } from '../../../hooks';
import styled from 'styled-components/native';
import { color, space, typography } from 'styled-system';
import Svg, { G, Path, Circle } from 'react-native-svg';
const SVG = styled(Svg)(color, space, typography);

const SVGIcon = ({
  viewBox,
  color: colorProp,
  stroke,
  strokeWidth,
  children,
  focusable,
  size,
  style
}, ref) => {
  const newProps = useThemeProps('Icon', {
    size
  });
  let strokeColor = useToken('colors', stroke || '');
  colorProp = useToken('colors', colorProp || '');
  return /*#__PURE__*/React.createElement(SVG, {
    height: parseInt(newProps.dimension || newProps.size, 10),
    width: parseInt(newProps.dimension || newProps.size, 10),
    viewBox: viewBox,
    color: colorProp,
    stroke: strokeColor,
    strokeWidth: strokeWidth,
    focusable: focusable,
    accessibilityRole: 'image',
    style: style,
    ref: ref
  }, React.Children.count(children) > 0 ? /*#__PURE__*/React.createElement(G, null, React.Children.map(children, ({
    props: childProps,
    type
  }) => type.name === 'Path' ? /*#__PURE__*/React.createElement(ChildPath, childProps) : null)) : getDefaultIcon(ref));
};

const ChildPath = ({
  fill,
  stroke: pathStroke,
  ...remainingProps
}) => {
  let pathStrokeColor = useToken('colors', pathStroke || '');
  let fillColor = useToken('colors', fill || '');
  return /*#__PURE__*/React.createElement(Path, _extends({}, remainingProps, {
    fill: fillColor ? fillColor : 'currentColor',
    stroke: pathStrokeColor
  }));
};

const getDefaultIcon = ref => {
  return /*#__PURE__*/React.createElement(G, {
    strokeWidth: 1.5,
    stroke: "currentColor",
    ref: ref
  }, /*#__PURE__*/React.createElement(Path, {
    d: 'M9,9a3,3,0,1,1,4,2.829,1.5,1.5,0,0,0-1,1.415V14.25',
    fill: "none"
  }), /*#__PURE__*/React.createElement(Path, {
    d: 'M12,17.25a.375.375,0,1,0,.375.375A.375.375,0,0,0,12,17.25h0',
    fill: "none"
  }), /*#__PURE__*/React.createElement(Circle, {
    cx: "12",
    cy: "12",
    r: "11.25",
    fill: "none"
  }));
};

export default /*#__PURE__*/React.memo( /*#__PURE__*/React.forwardRef(SVGIcon));
//# sourceMappingURL=SVGIcon.js.map