function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { StyleSheet } from 'react-native';
import { border, color, flexbox, layout, space, typography, position } from 'styled-system';
import { customBorder, customBackground, customOutline, customLayout, customExtra, customShadow, customTypography, customPosition } from '../../../utils/customProps';
import { useThemeProps, useToken } from '../../../hooks';
import styled from 'styled-components/native';
import { AntDesign, Entypo, EvilIcons, Feather, FontAwesome, FontAwesome5, Foundation, Ionicons, MaterialCommunityIcons, MaterialIcons, Octicons, SimpleLineIcons, Zocial } from '@expo/vector-icons';
import SVGIcon from './SVGIcon';
import { Path } from 'react-native-svg';

const Icon = (iconProps, ref) => {
  const {
    name,
    type,
    size,
    color: colorProp,
    ...props
  } = iconProps;
  const newProps = useThemeProps('Icon', {
    size,
    color: colorProp
  });
  const rawColor = useToken('colors', newProps.color);

  if (!name) {
    return /*#__PURE__*/React.createElement(SVGIcon, iconProps);
  }

  const flattenedIconStyle = StyleSheet.flatten([{
    fontSize: parseInt(newProps.size, 10)
  }]);

  switch (type) {
    case 'AntDesign':
      return /*#__PURE__*/React.createElement(AntDesign // TODO: remove this
      // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'Entypo':
      return /*#__PURE__*/React.createElement(Entypo // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'EvilIcons':
      return /*#__PURE__*/React.createElement(EvilIcons // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'Feather':
      return /*#__PURE__*/React.createElement(Feather // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'FontAwesome':
      return /*#__PURE__*/React.createElement(FontAwesome // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'FontAwesome5':
      return /*#__PURE__*/React.createElement(FontAwesome5 // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'Foundation':
      return /*#__PURE__*/React.createElement(Foundation // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'Ionicons':
      return /*#__PURE__*/React.createElement(Ionicons // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'MaterialCommunityIcons':
      return /*#__PURE__*/React.createElement(MaterialCommunityIcons // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'Octicons':
      return /*#__PURE__*/React.createElement(Octicons // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'SimpleLineIcons':
      return /*#__PURE__*/React.createElement(SimpleLineIcons // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    case 'Zocial':
      return /*#__PURE__*/React.createElement(Zocial // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));

    default:
      return /*#__PURE__*/React.createElement(MaterialIcons // @ts-ignore
      , _extends({
        name: name
      }, props, {
        style: flattenedIconStyle,
        color: rawColor,
        ref: ref
      }));
  }
};

const styledIcon = styled( /*#__PURE__*/React.forwardRef(Icon))(color, space, layout, flexbox, border, typography, position, customPosition, customBorder, customBackground, customOutline, customShadow, customExtra, customLayout, customTypography);
export default /*#__PURE__*/React.memo(styledIcon);
export { Path };
export { createIcon } from './createIcon';
//# sourceMappingURL=index.js.map